/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

'use strict';var e=require("@lexical/react/LexicalCollaborationContext"),g=require("@lexical/react/LexicalComposerContext"),n=require("@lexical/yjs"),D=require("react"),H=require("@lexical/utils"),I=require("lexical"),J=require("react-dom"),M=require("yjs"),N=require("react/jsx-runtime"),O=Object.create(null);if(D)for(var P in D)O[P]=D[P];O.default=D;
function Q(b,c,a,d,f,t,x,k,y,q,u,m){let l=D.useRef(!1),z=D.useCallback(()=>a.connect(),[a]),v=D.useCallback(()=>{try{a.disconnect()}catch(h){}},[a]);D.useEffect(()=>{let {root:h}=k,{awareness:E}=a,B=({status:p})=>{b.dispatchCommand(n.CONNECTED_COMMAND,"connected"===p)},F=p=>{x&&p&&h.isEmpty()&&0===h._xmlText._length&&!1===l.current&&R(b,u);l.current=!1},C=()=>{n.syncCursorPositions(k,a)},G=(p,A)=>{A=A.origin;A!==k&&n.syncYjsChangesToLexical(k,a,p,A instanceof M.UndoManager)};n.initLocalState(a,f,
t,document.activeElement===b.getRootElement(),m||{});let r=p=>{S(b,k);y(p);d.set(c,p);l.current=!0};a.on("reload",r);a.on("status",B);a.on("sync",F);E.on("update",C);h.getSharedType().observeDeep(G);let W=b.registerUpdateListener(({prevEditorState:p,editorState:A,dirtyLeaves:T,dirtyElements:U,normalizedNodes:V,tags:K})=>{!1===K.has("skip-collab")&&n.syncLexicalUpdateToYjs(k,a,p,A,U,T,V,K)}),L=z();return()=>{!1===l.current&&(L?L.then(v):v());a.off("sync",F);a.off("status",B);a.off("reload",r);E.off("update",
C);h.getSharedType().unobserveDeep(G);d.delete(c);W()}},[k,t,z,v,d,b,c,u,f,a,x,m,y]);let w=D.useMemo(()=>J.createPortal(N.jsx("div",{ref:h=>{k.cursorsContainer=h}}),q&&q.current||document.body),[k,q]);D.useEffect(()=>b.registerCommand(n.TOGGLE_CONNECT_COMMAND,h=>{h?(console.log("Collaboration connected!"),z()):(console.log("Collaboration disconnected!"),v());return!0},I.COMMAND_PRIORITY_EDITOR),[z,v,b]);return w}
function X(b,c,a,d,f){D.useEffect(()=>H.mergeRegister(b.registerCommand(I.FOCUS_COMMAND,()=>{n.setLocalStateFocus(c,a,d,!0,f||{});return!1},I.COMMAND_PRIORITY_EDITOR),b.registerCommand(I.BLUR_COMMAND,()=>{n.setLocalStateFocus(c,a,d,!1,f||{});return!1},I.COMMAND_PRIORITY_EDITOR)),[d,b,a,c,f])}
function Y(b,c){let a=D.useMemo(()=>n.createUndoManager(c,c.root.getSharedType()),[c]);D.useEffect(()=>H.mergeRegister(b.registerCommand(I.UNDO_COMMAND,()=>{a.undo();return!0},I.COMMAND_PRIORITY_EDITOR),b.registerCommand(I.REDO_COMMAND,()=>{a.redo();return!0},I.COMMAND_PRIORITY_EDITOR)));let d=D.useCallback(()=>{a.clear()},[a]);O.useEffect(()=>{let f=()=>{b.dispatchCommand(I.CAN_UNDO_COMMAND,0<a.undoStack.length);b.dispatchCommand(I.CAN_REDO_COMMAND,0<a.redoStack.length)};a.on("stack-item-added",
f);a.on("stack-item-popped",f);a.on("stack-cleared",f);return()=>{a.off("stack-item-added",f);a.off("stack-item-popped",f);a.off("stack-cleared",f)}},[b,a]);return d}
function R(b,c){b.update(()=>{var a=I.$getRoot();if(a.isEmpty())if(c)switch(typeof c){case "string":var d=b.parseEditorState(c);b.setEditorState(d,{tag:"history-merge"});break;case "object":b.setEditorState(c,{tag:"history-merge"});break;case "function":b.update(()=>{I.$getRoot().isEmpty()&&c(b)},{tag:"history-merge"})}else d=I.$createParagraphNode(),a.append(d),{activeElement:a}=document,(null!==I.$getSelection()||null!==a&&a===b.getRootElement())&&d.select()},{tag:"history-merge"})}
function S(b,c){b.update(()=>{let d=I.$getRoot();d.clear();d.select()},{tag:"skip-collab"});if(null!=c.cursors&&(b=c.cursors,null!=b&&(c=c.cursorsContainer,null!=c))){b=Array.from(b.values());for(let d=0;d<b.length;d++){var a=b[d].selection;if(a&&null!=a.selections){a=a.selections;for(let f=0;f<a.length;f++)c.removeChild(a[d])}}}}
function Z({editor:b,id:c,provider:a,yjsDocMap:d,name:f,color:t,shouldBootstrap:x,cursorsContainerRef:k,initialEditorState:y,awarenessData:q,collabContext:u,binding:m,setDoc:l}){c=Q(b,c,a,d,f,t,x,m,l,k,y,q);u.clientID=m.clientID;Y(b,m);X(b,a,f,t,q);return c}
exports.CollaborationPlugin=function({id:b,providerFactory:c,shouldBootstrap:a,username:d,cursorColor:f,cursorsContainerRef:t,initialEditorState:x,excludedProperties:k,awarenessData:y}){let q=D.useRef(!1),u=D.useRef(!1),m=e.useCollaborationContext(d,f),{yjsDocMap:l,name:z,color:v}=m,[w]=g.useLexicalComposerContext();D.useEffect(()=>{m.isCollabActive=!0;return()=>{null==w._parentEditor&&(m.isCollabActive=!1)}},[m,w]);let [h,E]=D.useState();D.useEffect(()=>{if(!u.current){u.current=!0;var r=c(b,l);
E(r);return()=>{r.disconnect()}}},[b,c,l]);let [B,F]=D.useState(l.get(b)),[C,G]=D.useState();D.useEffect(()=>{if(h&&!q.current){q.current=!0;var r=n.createBinding(w,h,b,B||l.get(b),l,k);G(r);return()=>{r.root.destroy(r)}}},[w,h,b,l,B,k]);return h&&C?N.jsx(Z,{awarenessData:y,binding:C,collabContext:m,color:v,cursorsContainerRef:t,editor:w,id:b,initialEditorState:x,name:z,provider:h,setDoc:F,shouldBootstrap:a,yjsDocMap:l}):N.jsx(N.Fragment,{})}
